//+------------------------------------------------------------------+
//|                                                     ekl_Lots.mq4 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, MetaQuotes Software Corp."
#property link      "http://www.mql4.com"
#property strict
#property indicator_chart_window
extern int tf = PERIOD_D1;
extern double risk = 0.02;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   string strComment = "";
   // string PipValue = DoubleToStr(NormalizeDouble(MarketInfo(Symbol(),MODE_TICKVALUE),4),4);
   strComment = StringConcatenate("COMA: ", COMA()," ----- ", "Lot Size: ", NormalizeDouble(LotSize(),2));
   Comment(strComment);
//--- return value of prev_calculated for next call
   return(rates_total);
  }

string COMA()
{
   double EMA1 = iMA(Symbol(), tf, 10, 0, MODE_EMA, PRICE_CLOSE,1);   
   double EMA2 = iMA(Symbol(), tf, 20, 0, MODE_EMA, PRICE_CLOSE,1);   
   double EMA3 = iMA(Symbol(), tf, 30, 0, MODE_EMA, PRICE_CLOSE,1);   
   double EMA4 = iMA(Symbol(), tf, 50, 0, MODE_EMA, PRICE_CLOSE,1);   
   double EMA5 = iMA(Symbol(), tf, 100, 0, MODE_EMA, PRICE_CLOSE,1);
   
   if(EMA1 < EMA2 && EMA2 < EMA3 && EMA3 < EMA4 && EMA4 < EMA5)
      return("Short");
   else if(EMA1 > EMA2 && EMA2 > EMA3 && EMA3 > EMA4 && EMA4 > EMA5)
      return("Long");
   else
      return("NA");
}
   

double LotSize()
{
   double EP, SL, Lots, PipValue, SLpips;
   PipValue = MarketInfo(Symbol(),MODE_TICKVALUE);
   if(StringFind(Symbol(), "JPY", 0) != -1) {
      EP = NormalizeDouble(ObjectGet("hlEP",OBJPROP_PRICE1),3);
      SL = NormalizeDouble(ObjectGet("hlSL",OBJPROP_PRICE1),3);
      SLpips = MathAbs(EP-SL)*100;
   }
   else  {
      EP = NormalizeDouble(ObjectGet("hlEP",OBJPROP_PRICE1),5);
      SL = NormalizeDouble(ObjectGet("hlSL",OBJPROP_PRICE1),5);
      SLpips = MathAbs(EP-SL)*10000;
   }
 
   Lots = AccountBalance() * risk / (SLpips * PipValue * 10);
   return(Lots);
}